//Datei: DS1821IO.C
// I/O-Routinen fr DS1821
//
// Holger Klabunde
// Copyright 2000
// 14.07.2001
// Compiler CC5x
// hk@holger-klabunde.de
// http://www.holger-klabunde.de

#include "prozess.h"      /* Der verwendete Prozessor */
#include "ser1821.h"
#include "protos.h"

//Abfragen ob Messung beendet ist
void PollStatus()
{
 do
  {
   MasterReset();
   SendByte(READSTATUS);
   ReadByte(8);
   if((tempbuf&0x80)>0) return; //Temp gemessen !
  }while(1);
}

//Sendet die Master Reset Sequenz
//Und fragt Presence ab
void MasterReset()
{
 DQT=1;                    //Fr Master Reset DQ=0;
 TMR0=0; while(TMR0<150);  //min. 480us
 DQT=0;                    //Leitung freigeben
 TMR0=0;  while(TMR0<25);  //min. 60us warten    
 while(DQ==0);             //Presence Pulse abwarten
 TMR0=0; while(TMR0<150);  //min. 480us warten
}

void SendByte(unsigned char dat)
{
 for(i=0; i<8; i++) //8Bits senden
  {
   RRF(dat,1); //Bit in Carry schieben
   if(!Carry) //Ein 0-Bit
    {
     DQT=1;                   //DQ=0 Jetzt min 60us warten
     TMR0=0; while(TMR0<18);  // min. 60us
    }
   else //Ein 1-Bit
    {
     DQT=1; //DQ=0 
     #asm
      nop   //Kurz warten
      nop
      nop
      nop
     #endasm
    } 

   DQT=0;   //DQ=1
   TMR0=0;  while(TMR0<25);  //Fr min. 60us warten    
  }
}

void ReadByte(unsigned char bi)
{
 
 mask=0x01;
 by=0;
 
 for(i=0; i<8; i++) //8 Bits empfangen
  {
   TMR0=0;
   DQT=1; //DQ=0
#asm
   nop
   nop //Kurz warten
   nop
   nop
#endasm   
   DQT=0;        //DQ=1 Leitung freigeben
   while(DQ==0); //Warten bis DQ auf 1 geht
   
   if(TMR0<4) by|=mask; //TMR0<16us ? Dann eine 1 empfangen
   TMR0=0; while(TMR0<25);  //Fr min. 60us warten    
   
   mask<<=1; //Nchstes Bit
  }

 tempbuf=by; //Wert merken

 if(bi==9)
  {
   TMR0=0;
   DQT=1; //DQ=0
#asm
   nop
   nop
   nop
   nop //Kurz warten
#endasm   
   DQT=0;        //DQ=1 Leitung freigeben
   while(DQ==0); //Warten bis DQ auf 1 geht

   if(TMR0<4) tempbuf+=0x100; //9tes Bit lesen
  }
 TMR0=0; while(TMR0<150);  //Fr min. 480us
}

